<?php
/*
 *      Patrick Bores - WebUserPrefs - SpamAssassin user_prefs file editor
 *      Copyright (C) 2003  Patrick Bores
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License
 *      as published by the Free Software Foundation; either version 2
 *      of the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


// SquirrelMail Authentication Module for WebUserPrefs
// by Patrick Bores
//
// Requires: SquirrelMail 1.4.0
// 
// This authentication module uses SquirrelMail's login system
// to authenticate users for WebUserPrefs. If the user is logged
// into SquirrelMail, the $auth_user variable will be set and
// the WebUserPrefs page will render. If not, the user should
// see a SquirrelMail login error.

// Configuration Section
// Configure the following variables for IMAP authentication.

// Set this to the path of the SquirrelMail distribution.
// This is the directory that contains "includes", "functions",
// "src", etc... It's a good idea to set this as a RELATIVE
// path, since SquirrelMail uses it in URLS as well as on the
// filesystem.

$squirrelmail_dir	= "../../";

// End of Configuration Section
// No modifications are required below this line.

define('SM_PATH',$squirrelmail_dir);
require_once("$squirrelmail_dir"."include/validate.php");
require_once("$squirrelmail_dir"."functions/global.php");
sqgetGlobalVar('username',$auth_user,SQ_SESSION);

if($auth_user == ""){
	exit;
}
